<template>
<div>
  <div class="not_dragging" :class="{dragging:showDropTarget()}"
    v-on:dragenter="dragEnterHandler($event)"
    v-on:dragleave="dragLeaveHandler($event)"
    v-on:dragover="dragOverHandler($event)"
    v-on:drop="dropHandler($event,'before')"></div>

    <div draggable="true" class="layer-element" :class="{editing:layer.editing}"
    v-on:mousedown="mouseDown($event)"
    v-on:dragstart="dragstartHandler($event)"
    v-on:dragenter="dragEnterHandler($event)"
    v-on:dragleave="dragLeaveHandler($event)"
    v-on:dragover="dragOverHandler($event)"
    v-on:drop="dropHandler($event,'after')"
    v-on:dragend="dragendHandler($event)">
      <b-container>
        <b-row>
          <b-col cols="2" md="1" class="m-0 p-0 text-center">
            <b-form-checkbox v-model="visible" switch></b-form-checkbox>
          </b-col>

          <b-col cols="8" md="9" class="m-0 p-0" @click="toggleActions()" >
            <span :id="'label_'+layer.id" class="truncate">
              <span v-if="layer.error !=='' " v-b-tooltip.hover :title="layer.error"
                style="cursor:help !important;">
                <b-icon icon="exclamation-triangle" variant="danger"></b-icon>
              </span>
                            {{layer.title}}
            </span>
          </b-col>

          <b-col cols="2" class="m-0 p-0 text-right" style="right:6px;">
            <span  v-if="!inRange" v-b-tooltip.hover
              title="La couche n'est pas visible à cette échelle"
              style="cursor:help !important;margin-right:6px;">
              <b-icon icon="eye-slash-fill" variant="secondary" ></b-icon>&nbsp;
            </span>
           <span @click="onClickInfo()" style="cursor:pointer !important;">
              <b-icon icon="info-circle" :id="'info_icon_'+layer.id" variant="info"></b-icon> &nbsp;
           </span>

            <b-popover :target="'info_icon_'+layer.id" triggers="hover" boundary="window"
              placement="right" :delay="{ show: 50, hide: 50 } ">
              <template #title>
                {{layer.title}}
                <b-badge variant="success">{{layer.type}}</b-badge>&nbsp;
                <b-badge v-if="layer.metadataUrl && layer.metadataUrl.length>0"
                  variant="info">Métadonnée disponible</b-badge>
              </template>
                {{layer.description}}<br/><br/>
              <span v-if="layer.metadataUrl && layer.metadataUrl.length>0"><em>
                cliquez sur le bouton pour ouvrir la fiche de métadonnées</em>
              </span>
            </b-popover>
          </b-col>
         </b-row>
                <b-row v-if="showActions" align-v="center" class="font_size_13 mb-2">
                    <b-col cols="1" class="m-0 p-0"></b-col>
                    <b-col cols="8" class="m-0 p-0"
                        draggable="true"
                        ondragstart="event.preventDefault();
                        event.stopPropagation();"
                        ><!-- pour empecher la propagation de l'event drag au parent et permettre l'utilisation du slider -->
                        Opacité &nbsp;
                        <b-form-input v-model="opacity"
                        type="range"
                        min="0"
                        max="1" step="0.1" class="w-50"
                        value="0"> </b-form-input>
                        &nbsp; {{ displayedOpacity }}%
                    </b-col>
                    <b-col cols="3" class="m-0 p-0 text-right">
                       <button class="btn btn-sm p-0 mx-0" style="margin-right:6px;"
                        v-b-tooltip.hover
                        @click="showTableAttribute()" title="Table Attributaire"
                        v-if="layer.hasWFSCapacity()"><!-- layer.hasTableCapacity() -->
                        <b-icon icon="table" variant="info"></b-icon>
                      </button>
                      <button class="btn btn-sm p-0 " style="margin-right:6px;"
                        v-b-tooltip.hover
                        @click="downloadLayer()" title="Télécharger" v-if="showDownloadBtn">
                        <b-icon icon="cloud-download" variant="info"></b-icon>
                      </button>

                        <button class="btn btn-sm p-0 " style="margin-right:6px;"
                          @click="zoomToLayer()"
                          v-b-tooltip.hover title="Zoomer sur l'étendue de la couche">
                            <b-icon icon="zoom-in" variant="secondary"></b-icon> &nbsp;
                        </button>

                        <button class="btn btn-sm p-0 " style="margin-right:6px;"
                          @click="infoLayer()" v-if="showConfigBtn"
                          v-b-tooltip.hover title="Configurer la couche">
                            <b-icon icon="gear" variant="primary"></b-icon> &nbsp;
                        </button>

                        <button class="btn btn-sm p-0" style="margin-right:6px;"
                          v-if="layer.editable && contextService.contentEditionIsAllowed"
                          v-b-tooltip.hover title="Éditer les données" @click="editLayer()">
                            <b-icon :icon="layer.editing ? 'pencil-fill':'pencil'"
                            variant="warning" ></b-icon> &nbsp;
                        </button>

                        <button class="btn btn-sm p-0"  style="margin-right:6px;"
                          @click="removeLayer()" v-b-tooltip.hover title="Supprimer la couche">
                            <b-icon icon="trash" variant="danger"></b-icon> &nbsp;
                        </button>
                    </b-col>
                </b-row >
                <DownloadPanel v-if="showDownLoad && showActions" :layer="layer"/>
                <FeatureListPanel v-if="showFeatureList && showActions"
                  :layer="layer" @close="showFeatureList=false"/>
            </b-container>
        </div>

        <div class="not_dragging" :class="{dragging:showDropTarget()}"
        v-on:dragenter="dragEnterHandler($event)"
        v-on:dragleave="dragLeaveHandler($event)"
        v-on:dragover="dragOverHandler($event)"
        v-on:drop="dropHandler($event,'after')"
        ></div>
    </div>
</template>

<script lang="ts">
/* eslint-disable no-param-reassign */
/* eslint-disable class-methods-use-this */
/* eslint-disable @typescript-eslint/explicit-module-boundary-types */
import LayerConfig from '@/models/map-context/LayerConfig';
import { EventBus, EVENTS } from '@/services/EventBus';
import DownloadPanel from '@/components/layers/DownloadPanel.vue';
import FeatureListPanel from '@/components/layers/FeatureListPanel.vue';
import Component from 'vue-class-component';
import BaseComponent from '../BaseComponent';

@Component({
  props: {
    layer: LayerConfig,
  },
  components: {
    DownloadPanel,
    FeatureListPanel,
  },
})
export default class SingleLayerElement extends BaseComponent {
  layer!: LayerConfig;

  showActions = false;

  showDownLoad = false;

  showFeatureList = false;

  target:any = null;

  showDownloadBtn = true;

  showConfigBtn = true;

  displayedOpacity = '100';

  mounted() {
    console.log(this.visible);
    if (this.is3DView()) {
      this.showDownloadBtn = false;
      if (this.beta === false) {
        this.showConfigBtn = false;
      }

      this.showActions = true;
    }
    this.displayedOpacity = `${parseFloat(this.opacity) * 100}`;
  }

  toggleActions() {
    this.showActions = !this.showActions;
  }

  get visible() :boolean {
    return this.layer.visible;
  }

  set visible(visibility:boolean) {
    this.layer.setVisible(!this.layer.visible);
  }

  get inRange() {
    // eslint-disable-next-line prefer-destructuring
    const currentScale = this.getMapService().currentScale;
    const maxScaleOk = !this.layer.maxScaleDenominator
        || (this.layer.maxScaleDenominator > currentScale);
    const minScaleOK = !this.layer.minScaleDenominator
        || (this.layer.minScaleDenominator < currentScale);
    return maxScaleOk && minScaleOK;
  }

  get opacity():string {
    if (this.layer.getOpacity()) {
      return `${this.layer.getOpacity()}`;
    }
    // eslint-disable-next-line quotes
    return "1";
  }

  set opacity(opacity:string) {
    console.log(opacity);
    this.displayedOpacity = `${parseFloat(opacity) * 100}`;
    this.layer.setOpacity(parseFloat(opacity));
  }

  onChange() {
    this.layer.setVisible(!this.layer.visible);
  }

  mouseDown(event:any): void {
    this.target = event.target;
  }

  dragstartHandler(event:any): void{
    console.log('drag start', this.target);
    if (this.target !== null) { // && (this.target.classList.contains('draggable')
    // || this.target.classList.contains('bi-justify'))
      this.contextService.setDraggingLayer(this.layer);
      event.dataTransfer.setData('text/plain', this.layer.id);
      // event.dataTransfer.setData('text/html', this.target.innerHTML);
      event.dataTransfer.effectAllowed = 'move'; // only allow moves
    } else {
      event.preventDefault();
    }
    console.log('drag start ok');
  }

  showDropTarget(): boolean {
    return false;
    // return this.contextService.getDraggingLayer() !== null
    //     && this.contextService.getDraggingLayer() !== this.layer;
  }

  showTableAttribute(): void {
    EventBus.$emit(EVENTS.OPEN_ATTRIBUTES, this.layer);
    this.contextService.tablelayer = this.layer;
    // this.showFeatureList = !this.showFeatureList;
  }

  onClickInfo() {
    if (this.layer.metadataUrl && this.layer.metadataUrl.length > 0) {
      window.open(encodeURIComponent(this.layer.metadataUrl), 'target=_blank');
    }
  }

  dragendHandler(event:any): void {
    event.preventDefault();
    console.log('drag end');
    this.contextService.setDraggingLayer(null);
  }

  dropHandler(event:any, target:string) {
    event.preventDefault();
    console.log(`drop ${target} ${this.layer.title}`);
    const dragLayer = this.contextService.getDraggingLayer();
    if (dragLayer !== null && dragLayer !== this.layer) {
      this.getMapService().changeLayerOrder(dragLayer, this.layer, target);
    }
  }

  dragEnterHandler(event:any) {
    event.preventDefault();
    // console.log('drag enter');
    // console.log(event);
    if (event.target !== undefined && event.target.style !== undefined
      && this.contextService.getDraggingLayer() !== this.layer) {
      event.target.classList.add('overed');
    }
  }

  dragLeaveHandler(event:any) {
    event.preventDefault();
    // console.log('drag leave');
    // console.log(event);
    if (event.target !== undefined && event.target.style !== undefined) {
      event.target.classList.remove('overed');
    }
  }

  dragOverHandler(event:any) {
    event.preventDefault();
    // console.log('drag over');
    if (event.dataTransfer !== null) {
      event.dataTransfer.dropEffect = 'move';
    }
  }

  editLayer() {
    console.log('edit layer');
    if (!this.layer.editing) {
      const editedLayer = this.getMapService().getLayerBeingEdited();
      if (editedLayer !== undefined) {
        editedLayer.editing = false;
      }
      EventBus.$emit(EVENTS.START_EDITION, this.layer);
    } else {
      EventBus.$emit(EVENTS.STOP_EDITION, this.layer);
    }
    this.layer.editing = !this.layer.editing;
  }

  infoLayer() {
    this.contextService.setCurrentAction('infoLayer', this.layer);
  }

  zoomToLayer() {
    this.getMapService().zoomToLayer(this.layer);
  }

  downloadLayer() {
    this.showDownLoad = !this.showDownLoad;
  }

  removeLayer() {
    this.getMapService().removeLayerFromList(this.layer);
    this.getMapService().removeLayerFromMap(this.layer);
  }
}
</script>

<style scoped lang="less">
@import "../../styles/variables.less";

.editing{
  font-weight: bold;
}

.layer-element{
    padding: 2px 0px;
    cursor: pointer;
}

input[type=range]{
    border: none !important;
    padding-top: 12px;
}
input[type=range]::-webkit-slider-runnable-track {
    height: 4px;
    border-radius: 3px;
    background: #b6b6b6;
}
input[type=range]::-webkit-slider-thumb {
    height: 12px;
    width: 12px;
    border-radius: 50%;
    background-color: @first;
}

.popover{
  max-width: 500px;
}
.not_dragging{
  display:none;
}

.dragging{
  display:block;
  background-color: lightgray;
  height: 3px;
}

.over-text{
  display:none;
}

.overed{
  /*height:30px;*/
  color:@first;
  font-weight: bold;
}

.edit-btn{
  cursor: pointer;
  color: '#A9CCE3'
}

.active{
  color: '#6c757d';
}
</style>
